aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorDave Chinner <dchinner@redhat.com>2018-05-11 12:11:52 +1000
committerEryu Guan <guaneryu@gmail.com>2018-05-16 10:03:03 +0800
commit5fc65da0a6ff5d8a0317ad3013ca7d244019b42b (patch)
treef96e52951a3004b1c743e87d2e1156c3486946b6
parent5c19a58f7d99567e2e664558f32fbacb11b169d3 (diff)
downloadxfstests-dev-5fc65da0a6ff5d8a0317ad3013ca7d244019b42b.tar.gz
xfs: test mount vs superblock shrinker races
Test case for superblock shrinkers running while the filesystem is being set up and/or torn down and tripping over inconsistent state. Signed-Off-By: Dave Chinner <dchinner@redhat.com> Reviewed-by: Eryu Guan <guaneryu@gmail.com> Signed-off-by: Eryu Guan <guaneryu@gmail.com>
-rwxr-xr-xtests/xfs/44772
-rw-r--r--tests/xfs/447.out2
-rw-r--r--tests/xfs/group1
3 files changed, 75 insertions, 0 deletions
diff --git a/tests/xfs/447 b/tests/xfs/447
new file mode 100755
index 0000000000..2f95afcecf
--- /dev/null
+++ b/tests/xfs/447
@@ -0,0 +1,72 @@
+#! /bin/bash
+# FS QA Test 447
+#
+# Exercise mount vs superblock shrinker races.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2018 Red Hat, Inc. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+ echo 0 > /sys/fs/xfs/debug/mount_delay
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+_supported_fs xfs
+_supported_os Linux
+
+_require_scratch
+_require_xfs_sysfs debug/mount_delay
+
+echo "Silence is golden"
+
+_scratch_mkfs > $seqres.full 2>&1
+_scratch_mount
+
+$XFS_IO_PROG -fxc "pwrite 0 4k" -c fsync \
+ -c "shutdown" $SCRATCH_MNT/foo 2>&1 > /dev_null
+
+_scratch_unmount
+
+echo 30 > /sys/fs/xfs/debug/mount_delay
+_scratch_mount
+echo 0 > /sys/fs/xfs/debug/mount_delay
+_scratch_unmount
+
+# success, all done
+status=0
+exit
diff --git a/tests/xfs/447.out b/tests/xfs/447.out
new file mode 100644
index 0000000000..6a0f966c0e
--- /dev/null
+++ b/tests/xfs/447.out
@@ -0,0 +1,2 @@
+QA output created by 447
+Silence is golden
diff --git a/tests/xfs/group b/tests/xfs/group
index c2e6677e90..51326d95ee 100644
--- a/tests/xfs/group
+++ b/tests/xfs/group
@@ -444,3 +444,4 @@
444 auto quick
445 auto quick filestreams
446 auto quick
+447 auto mount